using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace WindowsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        [DllImport("k8d.dll")]
        public static extern void Start_K8000();
        [DllImport("k8d.dll")]
        public static extern void Stop_K8000();
        [DllImport("k8d.dll")]
        public static extern void SelectI2CprinterPort(int port);
        [DllImport("k8d.dl")]
        public static extern void ConfigAllIOasInput();
        [DllImport("k8d.dll")]
        public static extern int ConfigIOchipAsInput(int Chipno);
        [DllImport("k8d.dll")]
        public static extern void ConfigAllIOasOutput();
        [DllImport("k8d.dll")]
        public static extern void ClearAllIO();
        [DllImport("k8d.dll")]
        public static extern void ClearIOchannel(int Channelno);
        [DllImport("k8d.dll")]
        public static extern void SetAllIO();
        [DllImport("k8d.dll")]
        public static extern void SetIOchannel(int Channelno);
        [DllImport("k8d.dll")]
        public static extern int ReadIOchip(int chip_no);
        [DllImport("k8d.dll")]
        public static extern void SetAllDAC();
        [DllImport("k8d.dll")]
        public static extern void ClearAllDAC();
        [DllImport("k8d.dll")]
        public static extern int ReadADchannel(int Channel_no);
        [DllImport("k8d.dll")]
        public static extern int OutputDACchannel(int Channel_no, int Data);
        [DllImport("k8d.dll")]
        public static extern int OutputDAchannel(int Channel_no, int Data);
        [DllImport("k8d.dll")]
        public static extern void I2CbusNotBusy();
        [DllImport("k8d.dll")]
        public static extern int SetIOchip(int Chipno);
        [DllImport("k8d.dll")]
        public static extern int ClearIOchip(int Chipno);
        private void button1_Click(object sender, EventArgs e)
        {
            SelectPort();
        }
        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            Stop_K8000();
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            /* set cardnumber and update labels */

        }
        private void button2_Click(object sender, EventArgs e)
        {
            SetAllIO();
            /* Set all outputs on */
            checkBox1.Checked = true;
            checkBox2.Checked = true;
            checkBox3.Checked = true;
            checkBox4.Checked = true;
            checkBox5.Checked = true;
            checkBox6.Checked = true;
            checkBox7.Checked = true;
            checkBox8.Checked = true;
            checkBox9.Checked = true;
            checkBox10.Checked = true;
            checkBox11.Checked = true;
            checkBox12.Checked = true;
            checkBox13.Checked = true;
            checkBox14.Checked = true;
            checkBox15.Checked = true;
            checkBox16.Checked = true;
            // read cardnumber
            int cardnr = vScrollBar6.Value;
            int i = (cardnr * 1) + 1;
            // set IO chips on
            SetIOchip(cardnr);
            SetIOchip(i);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            ClearAllIO();
            checkBox1.Checked = false;
            checkBox2.Checked = false;
            checkBox3.Checked = false;
            checkBox4.Checked = false;
            checkBox5.Checked = false;
            checkBox6.Checked = false;
            checkBox7.Checked = false;
            checkBox8.Checked = false;
            checkBox9.Checked = false;
            checkBox10.Checked = false;
            checkBox11.Checked = false;
            checkBox12.Checked = false;
            checkBox13.Checked = false;
            checkBox14.Checked = false;
            checkBox15.Checked = false;
            checkBox16.Checked = false;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            SetAllDAC();
        }

        private void button5_Click(object sender, EventArgs e)
        {
            ClearAllDAC();
        }

        private void button6_Click(object sender, EventArgs e)
        {
            // read cardnumber
            int cardnr = (vScrollBar6.Value * 4) + 1;
            // set IO chips on
            SetIOchip(cardnr);
            checkOutputs();
        }

        private void button7_Click(object sender, EventArgs e)
        {
            int cardnr = (vScrollBar6.Value * 4) + 1;
            int i;
            i = ReadADchannel(cardnr);
            label2.Text = i.ToString();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            // Get the date and time for the current moment, adjusted to the local time zone.
            String timeStr = "" + DateTime.Now;
            textBox1.Text = timeStr;
            DateTime dt = DateTime.Now;
            String[] format = {
                // d returns: month/day/fullyear eg: 12/30/2010
                // D returns: weekday calendarday monthname year eg:Thursday 30 December 2010
                // f returns: D+ hour:mintes eg:Thursday 30 December 2010 19:56
                // F returns: f+ seconds eg: Thursday 30 December 2010 19:56:25
                // g returns: d + hour:minutes eg: 12/30/2010 19:56
                // G returns: g + seconds eg: 12/30/2010 19:56:27
                // m returns: monthname/calendarday eg: December30
                // mm returns: minutes eg: 56
                // r returns for example Thu, 30 Dec 2010 19:56:27 GMT
                // s returns for example 2010-12-30T19:56:27
                // ss returns the seconds eg: 27
                // t returns: hours:minutes eg: 19:56
                // tt returns AM or PM
                // T returns: hour:minutes:seconds
                // U returns UTC time for example Thursday,30December2010 18:56:27
                // y returns: year and monthname eg: 2010 December
                // yyyy returns: year eg: 2010
                // ddd returns the first 3 characters of the dayname eg: Thu
                // MMMM returns the full monthname eg: December
                // MMM returns the first 3 characters of the monthname eg: Dec
           "HH:mm:ss"
        };
            // If you're using more than 1 member into the array use the following code:
            /* String date;
            for (int i = 0; i < format.Length; i++)
            {
                date = dt.ToString(format[i],System.Globalization.DateTimeFormatInfo.InvariantInfo);
                Console.WriteLine(String.Concat(format[i], " :", date));
            }*/

            String date;
            int i = 0;
            date = dt.ToString(format[i], System.Globalization.DateTimeFormatInfo.InvariantInfo);
            textBox1.Text = String.Concat(date);
            String dayName = "dddd";
            String dayNameStr = dt.ToString(dayName, System.Globalization.DateTimeFormatInfo.InvariantInfo);
            label21.Text = String.Concat(dayNameStr);
            // Update the scrollbarDAC's and labels
            String dayStr = "ddd";
            String dayWkStr = dt.ToString(dayStr, System.Globalization.DateTimeFormatInfo.InvariantInfo);
            if (dayWkStr == "Sun")
            {
                label25.Text = "0";
                pictureBox12.Height = 126;
                OutputDACchannel(4, 0);
            }
            if (dayWkStr == "Mon")
            {
                label25.Text = "1";
                pictureBox12.Height = 106;
                OutputDACchannel(4, 10);
            }
            if (dayWkStr == "Tue")
            {
                label25.Text = "2";
                pictureBox12.Height = 86;
                OutputDACchannel(4, 20);
            }
            if (dayWkStr == "Wed")
            {
                label25.Text = "3";
                pictureBox12.Height = 66;
                OutputDACchannel(4, 30);
            }
            if (dayWkStr == "Thu")
            {
                label25.Text = "4";
                pictureBox12.Height = 46;
                OutputDACchannel(4, 40);
            }
            if (dayWkStr == "Fri")
            {
                label25.Text = "5";
                pictureBox12.Height = 26;
                OutputDACchannel(4, 50);
            }
            if (dayWkStr == "Sat")
            {
                label25.Text = "6";
                pictureBox12.Height = 6;
                OutputDACchannel(4, 60);
            }
            // Convert the seconds to a number to set the height of the pictureBox9
            String sec = "ss";
            String secStr = dt.ToString(sec, System.Globalization.DateTimeFormatInfo.InvariantInfo);
            label22.Text = secStr;
            int s = dt.Second;
            pictureBox9.Height = 126 - (2 * s);
            OutputDACchannel(1, s);
            // Convert the minutes to a number to set the height f the pictureBox9
            String min = "mm";
            String minStr = dt.ToString(min, System.Globalization.DateTimeFormatInfo.InvariantInfo);
            label23.Text = minStr;
            int m = dt.Minute;
            pictureBox10.Height = 126 - (2 * m);
            OutputDACchannel(2, m);
            // Convert the hours to a number to set the height f the pictureBox9
            String hours = "HH";
            String hourStr = dt.ToString(hours, System.Globalization.DateTimeFormatInfo.InvariantInfo);
            label24.Text = hourStr;
            int h = dt.Hour;
            pictureBox11.Height = 126 - ((120 / 24) * h);
            int v = (60 / 24) * h;
            OutputDACchannel(3, v);
        }
        private void timer2_Tick(object sender, EventArgs e)
        {
            textBox2.Text = "No warnings...";
            UpdateADchannels();
        }
        private void vScrollBar1_Scroll(object sender, ScrollEventArgs e)
        {
            // DAC 5
            //int i;
            //i = ((Label51.Text + 1) * 8) - 3;
            int count = (63 - vScrollBar1.Value);
            String value = count.ToString();
            label26.Text = value;
            OutputDACchannel(5, 63 - vScrollBar1.Value);
        }

        private void vScrollBar2_Scroll(object sender, ScrollEventArgs e)
        {
            // DAC 6
            int count = (63 - vScrollBar2.Value);
            String value = count.ToString();
            label27.Text = value;
            OutputDACchannel(6, 63 - vScrollBar2.Value);
        }

        private void vScrollBar3_Scroll(object sender, ScrollEventArgs e)
        {
            // DAC 7
            int count = (63 - vScrollBar3.Value);
            String value = count.ToString();
            label28.Text = value;
            OutputDACchannel(7, 63 - vScrollBar3.Value);
        }

        private void vScrollBar4_Scroll(object sender, ScrollEventArgs e)
        {
            // DAC 8
            int count = (63 - vScrollBar4.Value);
            String value = count.ToString();
            label29.Text = value;
            OutputDACchannel(8, 63 - vScrollBar4.Value);
        }

        private void vScrollBar5_Scroll(object sender, ScrollEventArgs e)
        {
            // DA 1
            int count = (255 - vScrollBar5.Value);
            String value = count.ToString();
            label30.Text = value;
            OutputDAchannel(1, 255 - vScrollBar5.Value);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            // I2CbusNotBusy();
            Stop_K8000();
        }

        private void checkBox17_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox17.Checked == true)
            {
                if (checkBox18.Checked == true)
                {
                    label20.Text = "3";
                    vScrollBar6.Value = 3;
                }
                else
                {
                    label20.Text = "2";
                    vScrollBar6.Value = 2;
                }
            }
            if (checkBox17.Checked == false)
            {
                if (checkBox18.Checked == true)
                {
                    label20.Text = "1";
                    vScrollBar6.Value = 1;
                }
                else
                {
                    label20.Text = "0";
                    vScrollBar6.Value = 0;
                }
            }
            updateLabels();
        }

        private void checkBox18_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox18.Checked == true)
            {
                if (checkBox17.Checked == true)
                {
                    label20.Text = "3";
                    vScrollBar6.Value = 3;
                }
                else
                {
                    label20.Text = "1";
                    vScrollBar6.Value = 1;
                }
            }
            if (checkBox18.Checked == false)
            {
                if (checkBox17.Checked == true)
                {
                    label20.Text = "2";
                    vScrollBar6.Value = 2;
                }
                else
                {
                    label20.Text = "0";
                    vScrollBar6.Value = 0;
                }
            }
            updateLabels();
        }
        private void updateLabels()
        {
            int cardnr = vScrollBar6.Value;
            // set all labels to the actual cardnr
            // label3 -> 18 = I/O 1 -> I/O 18
            // Single-dimensional array (strings).
            string[] s2 = new string[] { "0", "1", "2" ,"3","4","5","6","7","8","9","10","11","12","13","14",
            "15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31","32","33","34",
            "35","36","37","38","39","40","41","42","43","44","45","46","47","48","49","50","51","52","53","54",
            "55","56","57","58","59","60","61","62","63","64"};
            String format = s2.ToString();
            int a = (cardnr * 16) + 1;
            label3.Text = s2[a].ToString();
            int b = (cardnr * 16) + 2;
            label4.Text = s2[b].ToString();
            int c = (cardnr * 16) + 3;
            label5.Text = s2[c].ToString();
            int d = (cardnr * 16) + 4;
            label6.Text = s2[d].ToString();
            int e = (cardnr * 16) + 5;
            label7.Text = s2[e].ToString();
            int f = (cardnr * 16) + 6;
            label8.Text = s2[f].ToString();
            int g = (cardnr * 16) + 7;
            label9.Text = s2[g].ToString();
            int h = (cardnr * 16) + 8;
            label10.Text = s2[h].ToString();
            int i = (cardnr * 16) + 9;
            label11.Text = s2[i].ToString();
            int j = (cardnr * 16) + 10;
            label12.Text = s2[j].ToString();
            int k = (cardnr * 16) + 11;
            label13.Text = s2[k].ToString();
            int l = (cardnr * 16) + 12;
            label14.Text = s2[l].ToString();
            int m = (cardnr * 16) + 13;
            label15.Text = s2[m].ToString();
            int n = (cardnr * 16) + 14;
            label16.Text = s2[n].ToString();
            int o = (cardnr * 16) + 15;
            label17.Text = s2[o].ToString();
            int p = (cardnr * 16) + 16;
            label18.Text = s2[p].ToString();
            // update DAC labels
            int q = (cardnr * 8) + 1;
            groupBox5.Text = s2[q].ToString();
            int r = (cardnr * 8) + 2;
            groupBox6.Text = s2[r].ToString();
            int s = (cardnr * 8) + 3;
            groupBox7.Text = s2[s].ToString();
            int t = (cardnr * 8) + 4;
            groupBox8.Text = s2[t].ToString();
            int u = (cardnr * 8) + 5;
            groupBox9.Text = s2[u].ToString();
            int v = (cardnr * 8) + 6;
            groupBox10.Text = s2[v].ToString();
            int w = (cardnr * 8) + 7;
            groupBox11.Text = s2[w].ToString();
            int x = (cardnr * 8) + 8;
            groupBox12.Text = s2[x].ToString();
            // update DA 1
            int y = (cardnr * 1) + 1;
            groupBox13.Text = "DA " + s2[y].ToString();
            // update AD 1 -> AD 4
            int z = (cardnr * 4) + 1;
            groupBox14.Text = "AD " + s2[z].ToString();
            int aa = (cardnr * 4) + 2;
            groupBox15.Text = "AD " + s2[aa].ToString();
            int ab = (cardnr * 4) + 3;
            groupBox16.Text = "AD " + s2[ab].ToString();
            int ac = (cardnr * 4) + 4;
            groupBox17.Text = "AD " + s2[ac].ToString();
            // update DAC labels label39 - 42
        }
        private void UpdateADchannels()
        {
            textBox2.Text = "No warnings...";
            int a = (vScrollBar6.Value * 4) + 1;
            int b = (vScrollBar6.Value * 4) + 2;
            int c = (vScrollBar6.Value * 4) + 3;
            int d = (vScrollBar6.Value * 4) + 4;
            int waardeAD1 = ReadADchannel(a);
            int waardeAD2 = ReadADchannel(b);
            int waardeAD3 = ReadADchannel(c);
            int waardeAD4 = ReadADchannel(d);
            if (waardeAD1 != 0)
            {
                /* If you want to use the code below, remove this line and the following characters: /*   */
                /*
                // Make warnings for the channel AD 1
                // 0C = 0V ; 1.153V = 37C max = 70C = 255
                // only from 0C -> 37C we can be sure
                // 255/3.642 = 70
                if (waardeAD1 <= 46)
                {
                    // Warning when temperature < 12.6C or 46 as value
                    textBox2.Text = "The temperature is falling.\r" +
                        "\nCheck inverters!";
                }
                if (waardeAD1 <= 43)
                {
                    // Alarm when temperature < 11.8C or 43 as value
                    textBox2.Text = "!!!Alarm!!!\r\nThe temperature is criticaly low!\r" +
                        "\nCheck inverters!";
                }
                if (waardeAD1 >= 91)
                {
                    // Warning when temperature > 25C or 91 as value
                    textBox2.Text = "The temperature is rising\r" +
                        "\nCheck ventilation!";
                }
                if (waardeAD1 >= 109)
                {
                    // Alarm when temperture > 30C or 109 as value
                    textBox2.Text = "!!!Alarm!!!\r\nThe temperature is criticaly high!\r" +
                        "\nCheck ventilators and ventilation";
                }
                */
                decimal temp = 3.64m;
                decimal temper1 = (waardeAD1 / temp);
                label31.Text = "" + temper1;
            }
            else
            {
                // With use of K8067 temperature sensor
                label31.Text = waardeAD1.ToString();
                /* If you want to use the code below, remove this line and the following characters: /*   */
                /*
                textBox2.Text ="An error has occured on channel AD" + a + ".\r\nSensor error!!.\r"+
                     "\nCheck the supply voltage or the kitn K8067.\r\n!!The temperature is criticaly low!! ";
                 */
            }
            pictureBox13.Height = 255 - (waardeAD1);
            if (waardeAD2 != 0)
            {
                label32.Text = waardeAD2.ToString();
            }
            else
            {
                label32.Text = waardeAD2.ToString();
                /* If you want to use the code below, remove this line and the following characters: /*   */
                /*
                 textBox2.Text = "An error has occured on channel AD" + b + ".\r\nSensor error!!.\r"+
                    "\nCheck the supply voltage or the kit.\r\n!!The temperature is criticaly low!! ";
                 */
            }
            pictureBox14.Height = 255 - (waardeAD2);
            // for example 3V on AD3
            // Readout as value: 0->255
            if (waardeAD3 != 0)
            {
                label33.Text = waardeAD3.ToString();
            }
            else
            {
                label33.Text = waardeAD3.ToString();
                /* If you want to use the code below, remove this line and the following characters: /*   */
                /*
                textBox2.Text = "The value of AD" + c + " is zero, please check the supply voltage.\r" +
                    "\nAn error has occured on channel AD" + c + ".\r\nThe supply voltage has fallen out.";
                 */
            }
            pictureBox15.Height = 255 - (waardeAD3);
            // for example 3V on AD4
            // 3V = +- 245 as value
            if (waardeAD4 != 0)
            {
                decimal v = 244.9m;
                decimal valV = (3 * (v / waardeAD4));
                label34.Text = "" + valV;
            }
            else
            {
                label34.Text = waardeAD4.ToString();
                /* If you want to use the code below, remove this line and the following characters: /*   */
                /*
                textBox2.Text = "The value of AD" + d + " is zero, please check the supply voltage.\r" +
                    "\nAn error has occured on channel AD" + d + ".\r\nThe supply voltage has fallen out.";
                 */
            }
            pictureBox16.Height = 255 - (waardeAD4);
            CheckErrors();
        }
        private void CheckErrors()
        {
            if (textBox2.Text == "No warnings...")
            {
                groupBox24.Text = "Running...";
                groupBox24.ForeColor = System.Drawing.Color.DarkGreen;
                pictureBox17.Visible = false;
            }
            else
            {
                pictureBox17.Visible = true;
                groupBox24.Text = "Warning!...";
                groupBox24.ForeColor = System.Drawing.Color.Red;
            }
            // Run the main program.
            StartProgram();
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked == true)
            {
                SetIOchannel(1);
            }
            else
            {
                ClearIOchannel(1);
            }
        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox2.Checked == true)
            {
                SetIOchannel(2);
            }
            else
            {
                ClearIOchannel(2);
            }
        }


        private void checkBox3_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox3.Checked == true)
            {
                SetIOchannel(3);
            }
            else
            {
                ClearIOchannel(3);
            }
        }

        private void checkBox4_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox4.Checked == true)
            {
                SetIOchannel(4);
            }
            else
            {
                ClearIOchannel(4);
            }
        }

        private void checkBox5_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox5.Checked == true)
            {
                SetIOchannel(5);
            }
            else
            {
                ClearIOchannel(5);
            }
        }

        private void checkBox6_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox6.Checked == true)
            {
                SetIOchannel(6);
            }
            else
            {
                ClearIOchannel(6);
            }
        }

        private void checkBox7_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox7.Checked == true)
            {
                SetIOchannel(7);
            }
            else
            {
                ClearIOchannel(7);
            }
        }

        private void checkBox8_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox8.Checked == true)
            {
                SetIOchannel(8);
            }
            else
            {
                ClearIOchannel(8);
            }
        }

        private void checkBox9_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox9.Checked == true)
            {
                SetIOchannel(9);
            }
            else
            {
                ClearIOchannel(9);
            }
        }

        private void checkBox10_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox10.Checked == true)
            {
                SetIOchannel(10);
            }
            else
            {
                ClearIOchannel(10);
            }
        }

        private void checkBox11_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox11.Checked == true)
            {
                SetIOchannel(11);
            }
            else
            {
                ClearIOchannel(11);
            }
        }

        private void checkBox12_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox12.Checked == true)
            {
                SetIOchannel(12);
            }
            else
            {
                ClearIOchannel(12);
            }
        }

        private void checkBox13_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox13.Checked == true)
            {
                SetIOchannel(13);
            }
            else
            {
                ClearIOchannel(13);
            }
        }

        private void checkBox14_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox14.Checked == true)
            {
                SetIOchannel(14);
            }
            else
            {
                ClearIOchannel(14);
            }
        }
        private void checkBox15_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox15.Checked == true)
            {
                SetIOchannel(15);
            }
            else
            {
                ClearIOchannel(15);
            }
        }

        private void checkBox16_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox16.Checked == true)
            {
                SetIOchannel(16);
            }
            else
            {
                ClearIOchannel(16);
            }
        }

        private void button9_Click(object sender, EventArgs e)
        {
            int cardnr = (vScrollBar6.Value * 4) + 2;
            int i;
            i = ReadADchannel(cardnr);
            label51.Text = i.ToString();
        }

        private void button10_Click(object sender, EventArgs e)
        {
            int cardnr = (vScrollBar6.Value * 4) + 3;
            int i;
            i = ReadADchannel(cardnr);
            label52.Text = i.ToString();
        }

        private void button11_Click(object sender, EventArgs e)
        {
            int cardnr = (vScrollBar6.Value * 4) + 4;
            int i;
            i = ReadADchannel(cardnr);
            label53.Text = i.ToString();
        }

        private void button12_Click(object sender, EventArgs e)
        {
            // read cardnumber
            int cardnr = vScrollBar6.Value * 4;
            // set IO chip on
            SetIOchip(cardnr);
            checkOutputsChip0();
        }

        private void button15_Click(object sender, EventArgs e)
        {
            // read cardnumber
            int cardnr = vScrollBar6.Value * 4;
            // turn IO chip off
            ClearIOchip(cardnr);
            checkOutputsChip0();
        }

        private void button16_Click(object sender, EventArgs e)
        {
            // read cardnumber
            int cardnr = (vScrollBar6.Value * 4) + 1;
            // turn IO chip off
            ClearIOchip(cardnr);
            checkOutputs();
        }
        private void checkOutputsChip0()
        {
            if (checkBox1.Checked == true)
            {
                checkBox1.Checked = false;
            }
            else
            {
                checkBox1.Checked = true;
            }
            if (checkBox2.Checked == true)
            {
                checkBox2.Checked = false;
            }
            else
            {
                checkBox2.Checked = true;
            }
            if (checkBox3.Checked == true)
            {
                checkBox3.Checked = false;
            }
            else
            {
                checkBox3.Checked = true;
            }
            if (checkBox4.Checked == true)
            {
                checkBox4.Checked = false;
            }
            else
            {
                checkBox4.Checked = true;
            }
            if (checkBox5.Checked == true)
            {
                checkBox5.Checked = false;
            }
            else
            {
                checkBox5.Checked = true;
            }
            if (checkBox6.Checked == true)
            {
                checkBox6.Checked = false;
            }
            else
            {
                checkBox6.Checked = true;
            }
            if (checkBox7.Checked == true)
            {
                checkBox7.Checked = false;
            }
            else
            {
                checkBox7.Checked = true;
            }
            if (checkBox8.Checked == true)
            {
                checkBox8.Checked = false;
            }
            else
            {
                checkBox8.Checked = true;
            }
        }
        private void checkOutputs()
        {
            if (checkBox9.Checked == true)
            {
                checkBox9.Checked = false;
            }
            else
            {
                checkBox9.Checked = true;
            }
            if (checkBox10.Checked == true)
            {
                checkBox10.Checked = false;
            }
            else
            {
                checkBox10.Checked = true;
            }
            if (checkBox11.Checked == true)
            {
                checkBox11.Checked = false;
            }
            else
            {
                checkBox11.Checked = true;
            }
            if (checkBox12.Checked == true)
            {
                checkBox12.Checked = false;
            }
            else
            {
                checkBox12.Checked = true;
            }
            if (checkBox13.Checked == true)
            {
                checkBox13.Checked = false;
            }
            else
            {
                checkBox13.Checked = true;
            }
            if (checkBox14.Checked == true)
            {
                checkBox14.Checked = false;
            }
            else
            {
                checkBox14.Checked = true;
            }
            if (checkBox15.Checked == true)
            {
                checkBox15.Checked = false;
            }
            else
            {
                checkBox15.Checked = true;
            }
            if (checkBox16.Checked == true)
            {
                checkBox16.Checked = false;
            }
            else
            {
                checkBox16.Checked = true;
            }
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            SelectPort();
        }

        private void radioButton3_CheckedChanged(object sender, EventArgs e)
        {
            SelectPort();
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            SelectPort();
        }
        private void SelectPort()
        {
            if (radioButton1.Checked == true)
            {
                SelectI2CprinterPort(1);
            }
            if (radioButton2.Checked == true)
            {
                SelectI2CprinterPort(2);
            }
            if (radioButton3.Checked == true)
            {
                SelectI2CprinterPort(0);
            }
            Start_K8000();
            ConfigAllIOasOutput();
        }

        private void button13_Click(object sender, EventArgs e)
        {
            /* Only use the following code if you will use IO-channels 1->8|17->24|33->40|49->56 as inputs,
               check also the IC's on the print!.
            int chipnr = vScrollBar6.Value;
            ConfigIOchipAsInput(chipnr);
            ReadIOchip(chipnr);
            label54.Text = chipnr.ToString();
             */
        }

        private void button14_Click(object sender, EventArgs e)
        {
            /* Only use the following code if you will use IO-channels 9->16/25->32/41->48/57->64 as inputs,
               depending on the cardnumber, check also the IC's on the print!.
           int chipnr2 = vScrollBar6.Value;
           ConfigIOchipAsInput(chipnr2);
           ReadIOchip(chipnr2);
           label55.Text = chipnr2.ToString();
            */
        }
        private void StartProgram()
        {
            // The main code will be entered here.
            // For example set output 1 every day at 19:00 on for 1 minute.
            // For example set output 2 every sunday at 19:00 on during 5 minutes.
            if (label24.Text == "19")
            {
                if (label23.Text == "00")
                {
                    SetIOchannel(1);
                    checkBox1.Checked = true;
                    if (label25.Text == "0")
                    {
                        SetIOchannel(2);
                        checkBox2.Checked = true;
                    }
                }
                if (label23.Text == "01")
                {
                    ClearIOchannel(1);
                    checkBox1.Checked = false;
                }
                if (label23.Text == "05")
                {
                    if (label25.Text == "0")
                    {
                        ClearIOchannel(2);
                        checkBox2.Checked = false;
                    }
                }
            }
            // For example set channel 3 on wednesday at 18:30 during 35 seconds.
            if (label23.Text == "30")
            {
                if (label25.Text == "3")
                {
                    if (label24.Text == "18")
                    {
                        int revHeight = pictureBox9.Height;
                        // revHeight = 126 pictureBox9 = seconds
                        // 126 - ((35 seconds *2 ) +8 ) = 48
                        if (revHeight >= 48)
                        {
                            if (checkBox3.Checked == false)
                            {
                                SetIOchannel(3);
                                checkBox3.Checked = true;
                            }
                        }
                        if (revHeight < 47)
                        {
                            if (checkBox3.Checked == true)
                            {
                                ClearIOchannel(3);
                                checkBox3.Checked = false;
                            }
                        }
                    }
                }
            }
            // Next code comes here.
        }
    }
}